// DInputDll.cpp
#include "stdafx.h"
#include "DInputDll.h"

// global variables
#pragma data_seg (".dinput_shared")
myIDirectInputDevice8*     gl_pmyIDirectInputDevice8Array[MAXNUMBER_DEVICES];
myIDirectInput8*           gl_pmyIDirectInput8;
//myIDirectInputEffect*    gl_pmyIDirectInputEffect;
HINSTANCE                  gl_hOriginalDll;
HINSTANCE                  gl_hThisInstance;
#pragma data_seg ()

BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	// to avoid compiler lvl4 warnings 
    LPVOID lpDummy = lpReserved;
    lpDummy = NULL;
    
    switch (ul_reason_for_call)
	{
	    case DLL_PROCESS_ATTACH: InitInstance(hModule); break;
	    case DLL_PROCESS_DETACH: ExitInstance(); break;
        
        case DLL_THREAD_ATTACH:  break;
	    case DLL_THREAD_DETACH:  break;
	}
    return TRUE;
}

// Exported function (faking dinput.dll's exports)
HRESULT WINAPI DirectInput8Create(HINSTANCE hinst, DWORD dwVersion, REFIID riidltf, LPVOID *ppvOut, LPUNKNOWN punkOuter)
{
	OutputDebugString("DI-PROXYDLL: In DirectInput8Create.\r\n");
	
	if (!gl_hOriginalDll) LoadOriginalDll(); // looking for the "right dinput.dll"
	
	typedef HRESULT (WINAPI* DirectInputCreate_Type)(HINSTANCE hinst, DWORD dwVersion, REFIID riidltf, LPVOID *ppvOut, LPUNKNOWN punkOuter);
	DirectInputCreate_Type DirectInputCreate_fn = (DirectInputCreate_Type) GetProcAddress( gl_hOriginalDll, "DirectInput8Create");
    
    // Debug
	if (!DirectInputCreate_fn) 
    {
        OutputDebugString("DI-PROXYDLL: Pointer to original DirectInput8Create function not received ERROR ****\r\n");
        ::ExitProcess(0); // exit the hard way
    }

	// Debug
	char tmp[150];
	sprintf(tmp, "DI-PROXYDLL: DirectInput8Create called with DIRECTINPUT_VERSION=%o \r\n",dwVersion);
    OutputDebugString(tmp);
	
	// REVIEW REVIEW REVIEW Instance Handle ! Original or own ? 
	// REVIEW REVIEW REVIEW Check for UNICODE or ANSI (riidltf) !
	HINSTANCE dummy = hinst;
	dummy = NULL;

	// Create real Interface
	LPVOID pIDirectInput_orig;
	HRESULT hr = DirectInputCreate_fn(gl_hThisInstance, dwVersion, riidltf, (LPVOID*) &pIDirectInput_orig, punkOuter);
	
	// Create my IDirectInput object and store pointer to original object there.
	// note: the object will delete itself once Ref count is zero (similar to COM objects)
	
	if (gl_pmyIDirectInput8) gl_pmyIDirectInput8->AddRef();
	else gl_pmyIDirectInput8 = new myIDirectInput8((IDirectInput8*)pIDirectInput_orig);
	
	// Return pointer to hooking Object instead of "real one"
	*ppvOut = gl_pmyIDirectInput8;
	return(hr);
}

// Exported function (faking dinput.dll's exports)
HRESULT WINAPI DllCanUnloadNow(void)
{
	OutputDebugString("DI-PROXYDLL: In DllCanUnloadNow.\r\n");
	
	if (!gl_hOriginalDll) LoadOriginalDll(); // looking for the "right dinput.dll"
	
	typedef HRESULT (WINAPI *DllCanUnloadNow_Type)(void);
	DllCanUnloadNow_Type DllCanUnloadNow_fn = (DllCanUnloadNow_Type) GetProcAddress( gl_hOriginalDll, "DllCanUnloadNow");
    
    // Debug
	if (!DllCanUnloadNow_fn) 
    {
        OutputDebugString("DI-PROXYDLL: Pointer to original DllCanUnloadNow function not received ERROR ****\r\n");
        ::ExitProcess(0); // exit the hard way
    }

	// Call original dll and return
	return(DllCanUnloadNow_fn());
}

HRESULT WINAPI DllGetClassObject (const CLSID &rclsid, const IID &riid, void **ppv)
{
	OutputDebugString("DI-PROXYDLL: In DllGetClassObject.\r\n");
	
	if (!gl_hOriginalDll) LoadOriginalDll(); // looking for the "right dinput.dll"
	
	typedef HRESULT (WINAPI *DllGetClassObject_Type)(const CLSID &rclsid, const IID &riid, void **ppv);
	DllGetClassObject_Type DllGetClassObject_fn = (DllGetClassObject_Type) GetProcAddress( gl_hOriginalDll, "DllGetClassObject");
    
    // Debug
	if (!DllGetClassObject_fn) 
    {
        OutputDebugString("DI-PROXYDLL: Pointer to original DllGetClassObject function not received ERROR ****\r\n");
        ::ExitProcess(0); // exit the hard way
    }

	// Call original dll and return
	return(DllGetClassObject_fn(rclsid, riid, ppv));
}

HRESULT WINAPI DllRegisterServer (void)
{
	OutputDebugString("DI-PROXYDLL: In DllRegisterServer.\r\n");
	
	if (!gl_hOriginalDll) LoadOriginalDll(); // looking for the "right dinput.dll"
	
	typedef HRESULT (WINAPI *DllRegisterServer_Type)(void);
	DllRegisterServer_Type DllRegisterServer_fn = (DllRegisterServer_Type) GetProcAddress( gl_hOriginalDll, "DllRegisterServer");
    
    // Debug
	if (!DllRegisterServer_fn) 
    {
        OutputDebugString("DI-PROXYDLL: Pointer to original DllRegisterServer function not received ERROR ****\r\n");
        ::ExitProcess(0); // exit the hard way
    }

	// Call original dll and return
	return(DllRegisterServer_fn());
}

HRESULT WINAPI DllUnregisterServer (void)
{
	OutputDebugString("DI-PROXYDLL: In DllUnregisterServer.\r\n");
	
	if (!gl_hOriginalDll) LoadOriginalDll(); // looking for the "right dinput.dll"
	
	typedef HRESULT (WINAPI *DllUnregisterServer_Type)(void);
	DllUnregisterServer_Type DllUnregisterServer_fn = (DllUnregisterServer_Type) GetProcAddress( gl_hOriginalDll, "DllUnregisterServer");
    
    // Debug
	if (!DllUnregisterServer_fn) 
    {
        OutputDebugString("DI-PROXYDLL: Pointer to original DllUnregisterServer function not received ERROR ****\r\n");
        ::ExitProcess(0); // exit the hard way
    }

	// Call original dll and return
	return(DllUnregisterServer_fn());
}

void InitInstance(HANDLE hModule) 
{
	OutputDebugString("DI-PROXYDLL: In InitInstance.\r\n");
	
	// Initialisation
    gl_pmyIDirectInput8       = NULL;
    
	for (int i=0; i<MAXNUMBER_DEVICES; i++) gl_pmyIDirectInputDevice8Array[i] = NULL;
	
    //gl_pmyIDirectInputEffect  = NULL
    gl_hOriginalDll           = NULL;
    gl_hThisInstance          = NULL;
	
	// Storing Instance handle into global var
	gl_hThisInstance = (HINSTANCE)  hModule;
}

void LoadOriginalDll(void)
{
    OutputDebugString("DI-PROXYDLL: In LoadOriginalDll.\r\n");
	
	char buffer[MAX_PATH];
    
    // Getting path to system dir and to dinput.dll
	::GetSystemDirectory(buffer,MAX_PATH);

	// Append dll name
	strcat(buffer,"\\dinput8.dll");
	
	// try to load the system's dinput.dll, if pointer empty
	if (!gl_hOriginalDll) gl_hOriginalDll = ::LoadLibrary(buffer);

	// Debug
	if (!gl_hOriginalDll)
	{
		OutputDebugString("DI-PROXYDLL: Original dinput8.dll not loaded ERROR ****\r\n");
		::ExitProcess(0); // exit the hard way
	}
}

void ExitInstance() 
{    
    OutputDebugString("DI-PROXYDLL: In ExitInstance.\r\n");
	
	// Release the system's dinput8.dll
	if (gl_hOriginalDll)
	{
		::FreeLibrary(gl_hOriginalDll);
	    gl_hOriginalDll = NULL;  
	}
}
